package dados;

import java.io.Serializable;
import java.util.Vector;

import dados.usuario.Usuario;

import dados.exception.OperacaoInvalidaException;
import dados.locacao.Periodo;

public class Operacao implements Serializable {

	private static final long serialVersionUID = 1L;

	private long codigo;
	private TipoOperacao tipoOperacao;
	private Vector<Object> parametros;

	public Operacao(TipoOperacao tipo, Vector<Object> parametros) throws OperacaoInvalidaException{

		if(tipo != null && parametros != null){

			switch(tipo){

			case ALTERARDADOSUSUARIO:
				if(parametros.size() == 1){
					if(parametros.get(0) != null){
						if(parametros.get(0) instanceof Usuario){
							this.tipoOperacao = tipo;
							this.parametros = parametros;
						} else {
							throw new OperacaoInvalidaException();
						}
					} else {
						throw new OperacaoInvalidaException();
					}
				} else {
					throw new OperacaoInvalidaException();
				}
				break;
			case DESCADASTRARUSUARIO:
				if(parametros.size() == 2){
					if(parametros.get(0) != null && parametros.get(1) != null){
						if(parametros.get(0) instanceof Long && parametros.get(1) instanceof String){
							this.tipoOperacao = tipo;
							this.parametros = parametros;
						} else {
							throw new OperacaoInvalidaException();
						}
					} else {
						throw new OperacaoInvalidaException();
					}
				} else {
					throw new OperacaoInvalidaException();
				}
				break;
			case CADASTRARCLIENTE:
				if(parametros.size() == 1){
					if(parametros.get(0) != null){
						if(parametros.get(0) instanceof Usuario){
							this.tipoOperacao = tipo;
							this.parametros = parametros;
						} else {
							throw new OperacaoInvalidaException();
						}
					} else {
						throw new OperacaoInvalidaException();
					}
				} else {
					throw new OperacaoInvalidaException();
				}
				break;
			case CADASTRARDEPENDENTE:
				if(parametros.size() == 5){
					boolean nulo = false;
					for(int i = 0; i < 5; i++){
						if(parametros.get(i) == null){
							nulo = true;
						}
					}

					if(!nulo){
						if(parametros.get(0) instanceof Long && parametros.get(1) instanceof String
								&& parametros.get(2) instanceof String && parametros.get(3) instanceof String
								&& parametros.get(4) instanceof Long){

							this.tipoOperacao = tipo;
							this.parametros = parametros;
						} else {
							throw new OperacaoInvalidaException();
						}
					}else {
						throw new OperacaoInvalidaException();
					}
				} else {
					throw new OperacaoInvalidaException();
				}
				break;
			case DEVOLVERPRODUTO:
				if(parametros.size() == 2){
					boolean nulo = false;
					for(int i = 0; i < 2; i++){
						if(parametros.get(i) == null){
							nulo = true;
						}
					}

					if(!nulo){
						if(parametros.get(0) instanceof Integer && parametros.get(1) instanceof String){
							this.tipoOperacao = tipo;
							this.parametros = parametros;
						} else {
							throw new OperacaoInvalidaException();
						}
					} else {
						throw new OperacaoInvalidaException();
					}
				} else {
					throw new OperacaoInvalidaException();
				}
				break;
			case INSERIRLOCACAO:
				if(parametros.size() == 3){
					boolean nulo = false;
					for(int i = 0; i < 3; i++){
						if(parametros.get(i) == null){
							nulo = true;
						}
					}

					if(!nulo){
						if(parametros.get(0) instanceof Long && parametros.get(1) instanceof Integer && parametros.get(2) instanceof Periodo){
							this.tipoOperacao = tipo;
							this.parametros = parametros;
						} else {
							throw new OperacaoInvalidaException();
						}
					} else {
						throw new OperacaoInvalidaException();
					}
				} else {
					throw new OperacaoInvalidaException();
				}
				break;
			}
		} else {
			throw new IllegalArgumentException();
		}
	}

	public TipoOperacao getTipoOperacao() {
		return this.tipoOperacao;
	}

	public void setTipoOperacao(TipoOperacao tipoOperacao) {
		this.tipoOperacao = tipoOperacao;
	}

	public Vector<Object> getParametros() {
		return this.parametros;
	}

	public void setParametros(Vector<Object> parametros) {
		this.parametros = parametros;
	}

	@Override
	public boolean equals(Object obj) {
		return this.codigo == ((Operacao) obj).getCodigo();
	}
	
	@Override
	public String toString() {
		String retorno = "";
		
		switch(this.tipoOperacao){
		
		case ALTERARDADOSUSUARIO:
			retorno = retorno +  "Alterar cadastro de usurio";
			break;
		case DESCADASTRARUSUARIO:
			retorno = retorno + "Remover cadastro de usurio";
			break;
		case CADASTRARCLIENTE:
			retorno = retorno + "Cadastrar cliente";
			break;
		case CADASTRARDEPENDENTE:
			retorno = retorno + "Cadastrar dependente";
			break;
		case DEVOLVERPRODUTO:
			retorno = retorno + "Devoluo de cpia";
			break;
		case INSERIRLOCACAO:
			retorno = retorno + "Inserir locao";
			break;
		}
		
		for(int i = 0; i < this.parametros.size(); i++){
			retorno = retorno + "     " + this.parametros.get(i).toString();
		}
		
		return retorno;
	}

	public long getCodigo() {
		return codigo;
	}

	public void setCodigo(long codigo) {
		this.codigo = codigo;
	}

}
