package gui;
import java.awt.event.ActionEvent;
import javax.swing.JLabel;
import javax.swing.JTextField;

import negocio.exception.CampoInvalidoException;

import dados.exception.EnderecoInvalidoException;
import dados.filial.Endereco;
import dados.usuario.Cliente;

public class PainelEndereco extends PainelOpaco {

	private static final long serialVersionUID = 1L;

	private JLabel labelLogradouro;
	private JLabel labelBairro;
	private JLabel labelNumero;
	private JLabel labelCidade;
	private JLabel labelEstado;
	private JLabel labelComplemento;
	private JLabel labelCEP;

	private JTextField textoLogradouro;
	private JTextField textoBairro;
	private JTextField textoNumero;
	private JTextField textoCidade;
	private JTextField textoEstado;
	private JTextField textoComplemento;
	private JTextField textoCEP;

	public PainelEndereco(JanelaFilial janela) {
		super("Endereco", janela);

		labelLogradouro = criarRotulo("Logradouro:", 20, 20, 200, 30);
		labelBairro = criarRotulo("Bairro:", 20, 70, 150, 30);
		labelNumero = criarRotulo("N:", 210, 70, 70, 30);
		labelCidade = criarRotulo("Cidade: ", 20, 120, 100, 30);
		labelEstado = criarRotulo("Estado:", 210, 120, 150, 30);		
		labelComplemento = criarRotulo("Complemento:", 20, 170, 200, 30);
		labelCEP = criarRotulo("CEP:", 220, 170, 80, 30);

		textoLogradouro = criarCampo(150, 20, 200, 25);
		textoBairro = criarCampo(100, 70, 100, 25);
		textoNumero = criarCampo(270, 70, 100, 25);
		textoCidade = criarCampo(100, 120, 100, 25);
		textoEstado = criarCampo(270, 120, 70, 25);
		textoComplemento = criarCampo(130, 170, 70, 25);
		textoCEP = criarCampo(270, 170, 100, 25);

		this.setSize(390, 230);
	}

	public Endereco getEndereco() throws EnderecoInvalidoException, CampoInvalidoException {
		Endereco e = null;
		String logradouro = this.textoLogradouro.getText().trim();
		String estado = this.textoEstado.getText().trim();
		String numero = this.textoNumero.getText().trim();
		String complemento = this.textoComplemento.getText().trim();
		String cidade = this.textoCidade.getText().trim();
		String bairro = this.textoBairro.getText().trim();
		String cep = this.textoCEP.getText().trim();
			if(!logradouro.equals("") && !estado.equals("") && !numero.equals("") && !complemento.equals("") && !cidade.equals("") && !bairro.equals("") && !cep.equals("")) {
				e = new Endereco(logradouro, estado, cidade, bairro, complemento, Integer.parseInt(numero), Integer.parseInt(cep));
			}else{
				throw new CampoInvalidoException();
			}
		return e;
	}
	
	public void setEndereco(Cliente c) {
		Endereco e = c.getEndereco();
		this.textoBairro.setText(e.getBairro());
		this.textoCEP.setText(""+e.getCep());
		this.textoCidade.setText(e.getCidade());
		this.textoComplemento.setText(e.getComplemento());
		this.textoEstado.setText(e.getEstado());
		this.textoLogradouro.setText(e.getLogradouro());
		this.textoNumero.setText(e.getNumero() + "");
	}

	@Override
	public void actionPerformed(ActionEvent arg0) {}

	public void limpar(){
		this.textoBairro.setText("");
		this.textoCEP.setText("");
		this.textoCidade.setText("");
		this.textoComplemento.setText("");
		this.textoEstado.setText("");
		this.textoLogradouro.setText("");
		this.textoNumero.setText("");
		
	}

	public void habilitarCamposEndereco(boolean b) {
		this.textoBairro.setEditable(b);
		this.textoCEP.setEditable(b);
		this.textoCidade.setEditable(b);
		this.textoComplemento.setEditable(b);
		this.textoEstado.setEditable(b);
		this.textoLogradouro.setEditable(b);
		this.textoNumero.setEditable(b);
	}

}
