package gui;
import java.awt.Component;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.rmi.RemoteException;

import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPasswordField;
import javax.swing.JTextField;

import negocio.exception.FilialInexistenteException;
import negocio.exception.SenhaInvalidaException;
import negocio.exception.UsuarioInexistenteException;
import negocio.exception.UsuarioLogadoException;

import fachada.Fachada;

public class PainelLogin extends PainelFigura {

	private static final long serialVersionUID = 1L;

	private JLabel labelLogin;
	private JLabel labelCPFUsuario;
	private JLabel labelSenha;
	private JButton botao;

	private JTextField textoCPF;
	private JPasswordField textoSenha; 

	public PainelLogin(JanelaFilial janela){
		super("images/telaSecundaria.png", janela);

		labelLogin = criarRotulo("Login", 355, 60, 200, 50);
		labelCPFUsuario = criarRotulo("CPF do Funcionrio:", 310, 150, 200, 30);
		labelSenha = criarRotulo("Senha:", 350, 250, 200, 30);
		textoCPF = criarCampo(295, 185, 170, 25);
		textoSenha = new JPasswordField();
		textoSenha.setLocation(295, 285);
		textoSenha.setSize(170,25);
		textoSenha.setVisible(true);
		this.add(textoSenha);
		labelLogin.setFont(new Font("Arial",Font.BOLD ,20));
		botao = criarBotao("Logar", 320, 470, 120, 40);
	}

	public void limpar(){
		textoCPF.setText("");
		textoSenha.setText("");
	}

	@Override
	public void actionPerformed(ActionEvent a) {

		Component c = (Component) a.getSource();

		try {
			Fachada f = Fachada.getInstancia(this.janelaPrincipal);

			if(c == botao){
				String cpfString = textoCPF.getText();
				String senha = new String(textoSenha.getPassword());
				if(!cpfString.isEmpty() && !senha.isEmpty()){
					long cpf = Long.parseLong(cpfString);
					f.logar(cpf, senha);
					this.limpar();
					this.janelaPrincipal.habilitarFuncionarioLogado(true);
					this.janelaPrincipal.trocarPainel(this.janelaPrincipal.getPainelInicial());
					JOptionPane.showMessageDialog(this, "Usurio com CPF "+cpf+" logado com sucesso!", "Login Realizado", JOptionPane.INFORMATION_MESSAGE);
				}
			}
		}catch(NumberFormatException nfe){
			JOptionPane.showMessageDialog(this, "Preencha o campo com nmero", "Ateno", JOptionPane.ERROR_MESSAGE);
		} catch (RemoteException e) {
			JOptionPane.showMessageDialog(this, "A filial est fora do ar", "Erro!", JOptionPane.ERROR_MESSAGE);
		} catch (UsuarioLogadoException e) {
			JOptionPane.showMessageDialog(this, "O usuario j est logado", "Erro!", JOptionPane.ERROR_MESSAGE);
		} catch (UsuarioInexistenteException e) {
			JOptionPane.showMessageDialog(this, "Usurio incexistente", "Erro!", JOptionPane.ERROR_MESSAGE);
		} catch (SenhaInvalidaException e) {
			JOptionPane.showMessageDialog(this, "Senha invlida", "Erro!", JOptionPane.ERROR_MESSAGE);
		} catch (FilialInexistenteException e) {
			JOptionPane.showMessageDialog(this, "Filial inexistente", "Erro!", JOptionPane.ERROR_MESSAGE);
		}
		
		this.textoSenha.setText("");
	}
}