package negocio;

import negocio.exception.EntregaInexistenteException;
import util.IteratorBidirecional;
import dados.Entrega;
import armazenamento.RepositorioEntrega;

public class GerenciadorEntregas {
	
	private static GerenciadorEntregas instancia;
	private RepositorioEntrega repositorio;
	
	static{
		GerenciadorEntregas.instancia = new GerenciadorEntregas();
	}
	
	private GerenciadorEntregas(){
		this.repositorio = RepositorioEntrega.getInstancia();
	}
	
	public static GerenciadorEntregas getInstancia(){
		return GerenciadorEntregas.instancia;
	}
	
	public void inserirEntrega(Entrega entrega){
		this.repositorio.inserirEntrega(entrega);
	}
	
	public void removerEntrega(int codigoCopia){
		this.repositorio.removerEntrega(codigoCopia);
	}

	public IteratorBidirecional<Entrega> getEntregas() throws EntregaInexistenteException{
		IteratorBidirecional<Entrega> it = this.repositorio.getEntregas();
		if(it.hasNext()){
			return it;
		} else {
			throw new EntregaInexistenteException();
		}
	}
}
