package negocio;

import armazenamento.RepositorioPlanoOffline;

import dados.usuario.Plano;

import util.IteratorBidirecional;


public class GerenciadorPlanoOffline {

	private static GerenciadorPlanoOffline instancia;
	private RepositorioPlanoOffline repositorio;

	static{
		GerenciadorPlanoOffline.instancia = new GerenciadorPlanoOffline();
	}

	private GerenciadorPlanoOffline(){
		this.repositorio = RepositorioPlanoOffline.getInstancia();
	}

	public static GerenciadorPlanoOffline getInstancia(){
		return GerenciadorPlanoOffline.instancia;
	}

	public IteratorBidirecional<Plano> getPlanos(){
		return this.repositorio.getPlanos();
	}
	
	public void atualizarPlanos(IteratorBidirecional<Plano> planos){
		this.repositorio.atualizarPlanos(planos);
	}

}
