package servicos;

import java.rmi.RemoteException;
import java.rmi.server.UnicastRemoteObject;

import dados.Entrega;
import dados.filial.Endereco;
import dados.locacao.Locacao;
import dados.locacao.Reserva;
import fachada.Fachada;

public class InterfaceFilialImp extends UnicastRemoteObject implements InterfaceFilial {

	private static final long serialVersionUID = 1L;
	
	public InterfaceFilialImp() throws RemoteException {
		super();
	}

	@Override
	public synchronized void notificarLocacaoDomicilio(Locacao locacao, Endereco endereco) throws RemoteException {
		System.out.println("Notificao entrega recebida");
		Fachada.getInstancia(null).inserirEntrega(new Entrega(locacao, endereco));
		
	}
	
	@Override
	public synchronized void notificarReserva(Reserva reserva) throws RemoteException{
		System.out.println("Notificao reserva recebida");
		Fachada.getInstancia(null).notificarReserva(reserva);
	}
	
	@Override
	public synchronized void notificarRemocaoReserva(Reserva reserva) throws RemoteException{
		System.out.println("Notificao reserva removida");
		Fachada.getInstancia(null).notificarRemocaoReserva(reserva);
	}

}
